﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace xamTreeGrid {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {
        public MainWindow() {
            InitializeComponent();
        }
    }


    public class SampleData {
        private ObservableCollection<TestStructure> _data;

        public ObservableCollection<TestStructure> Data {
            get {
                if(_data == null) {
                    _data = ReadData();
                }
                return _data;
            }
        }

        private ObservableCollection<TestStructure> ReadData() {
            return new ObservableCollection<TestStructure> {
                new TestStructure{ Title="item 1",Child=new ObservableCollection<TestStructure>{new TestStructure{Title="item 1-1"},new TestStructure{Title="item 1-2"},new TestStructure{Title="item 1-3"}}}
               ,new TestStructure{ Title="item 2",Child=new ObservableCollection<TestStructure>{new TestStructure{Title="item 2-1"},new TestStructure{Title="item 2-2"},new TestStructure{Title="item 2-3"}}}
            };
        }
    }

    public class TestStructure : INotifyPropertyChanged {
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName) {
            if(PropertyChanged != null) {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion

        private string _title;

        public string Title {
            get { return _title; }
            set {
                _title = value;
                OnPropertyChanged("Title");
            }
        }

        private bool _isOpen;

        public bool IsOpen {
            get { return _isOpen; }
            set {
                _isOpen = value;
                OnPropertyChanged("IsOpen");
                Console.WriteLine("IsOpen = ", value);
            }
        }


        private ObservableCollection<TestStructure> _childs;

        public ObservableCollection<TestStructure> Child {
            get { return _childs; }
            set {
                _childs = value;
                OnPropertyChanged("Child");
            }
        }


    }
}
